function [ exists ] = file_exist(file_path, base_path)
%FILE_EXIST Checks whether a file exists and is readable.

if(nargin < 1)
    exists = false;
    return;
end

if(exist('base_path', 'var'))
    file_path = fullfile(base_path, file_path);
end

cmd = strcat('test -r "', file_path, '"');
exists = exist(file_path, 'file') && ~unix(cmd);

end

