function W = gen_network_sf(n, gamma)

if nargin < 2
	gamma = -2.5;
end

W = cnp_gen_scalefree_net(n, gamma);
strong = true;
W = get_largest_conncomp(W, true, strong);

W = W - diag(diag(W)) + eye(size(W, 1)); 
[r, c, v] = find(W);
v = rand(length(v), 1);
W = sparse(r, c, v, size(W, 1), size(W, 1));

W = add_dominant_self_loops(W);

W = rowstoch(W);

n = size(W, 1);
m = nnz(W);
network_name = sprintf('SF^{%0.1f}', gamma);

end