function [ Ars ] = rowstoch(A)
%ROWSTOCH Scales A's rows, so that the resulting matrix Ars is row-stochastic

Ars = A;
n = size(A, 1);
rowsums = sum(A, 2);
rowsums(abs(rowsums) < eps) = 1;
if issparse(A)
	D = spdiags(1 ./ rowsums, 0, n, n);
else
	D = diag(1 ./ rowsums);
end
Ars = D * Ars;

end

