#ifndef __DEBUG_H__
#define __DEBUG_H__

#include <string>
#include "mex_safe.h"

#ifdef DEBUG
	#ifndef SUB2IND
		#define SUB2IND(i, j, nrows) ((j) * (nrows) + (i))
	#endif
	#define PRINT(msg) mexPrintf_safe(std::string((msg)).c_str());
	#define PRINTMXARRAY(mxarr) mexCallMATLAB_safe(0, NULL, 1, &mxarr, "disp");
	#define PRINTARRAY(arr, len) for (int64_t __arr_index__ = 0; __arr_index__ < len; ++__arr_index__) { PRINT((std::to_string((arr)[__arr_index__]) + " ").c_str()) };
	#define PRINTMAT(mat, n, m) for (uint64_t __i__ = 0; __i__ < (n); ++__i__) {\
		for (uint64_t __j__ = 0; __j__ < (m); ++__j__) {\
			PRINT((std::to_string(\
				(mat)[ SUB2IND(__i__, __j__, (n)) ]\
			) + " ").c_str());\
		}\
		PRINT("\n");\
	};
	#define ASSERT(cnd, msg) if(!(cnd)) { mexErrMsgTxt_safe(std::string((msg)).c_str()); };
	#define ASSERTARREQ(a, b, len, msg) for(uint64_t __i__ = 0; __i__ < (len); ++__i__) { ASSERT((a)[__i__] == (b)[__i__], ("[" + std::to_string(__i__) + "]:" + std::string((msg)))); };
#else
	#define PRINT(msg);
	#define PRINTMXARRAY(mxarr);
	#define PRINTARRAY(arr, len);
	#define PRINTMAT(MAT, N, M);
	#define ASSERT(cnd, msg);
	#define ASSERTARREQ(a, b, len, msg);
#endif

#endif // __DEBUG_H__